<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class admin
{
private $url;
private $user;
private $pw;
private $list_perpage=10;
private $filename="database/db.php";
private $configfile;

private function validate_user()
{
    if (!($this->validate_url())){return false;}
    if ($this->validate_pw()){return true;}
    if (file_exists("database/settings.php")){
        $f=file("database/settings.php");
        return ((($_SESSION['admin'])=='yes') && ($f[1]==bin2hex($this->pw).bin2hex($this->user).bin2hex($_SERVER['REMOTE_ADDR'])));
    }
    return false;
}

private function validate_url()
{
    $selfurl = str_replace("www.","", strtolower(getenv("HTTP_HOST")));
    return ($selfurl===$this->url);
}

private function validate_pw()
{
  if (!(isset($_POST['password']))&&(isset($_POST['name']))){return false;}
  $name=bin2hex($this->strip_slashes(trim($_POST['name'])));
  $pass=bin2hex($this->strip_slashes(trim($_POST['password'])));
  if(($pass==bin2hex($this->pw))&&($name==bin2hex($this->user))){
      $_SESSION['admin']='yes';
      $handle=@fopen("database/settings.php" , 'w');
      fwrite($handle,"<?php exit; ?>");
      fwrite($handle,"\n");
      fwrite($handle, bin2hex($this->pw).bin2hex($this->user).bin2hex($_SERVER['REMOTE_ADDR']));
      fclose($handle);
      return true;
  }
  return false;
}

private function log_out()
{
    if (($_SESSION['admin'])=='yes'){
        unset($_SESSION['admin']);
        @file_put_contents("database/settings.php", "");
        $this->log_in();
    }
}


private function total_page($c, $p)
{
    if ($c<=1){ return 0; }
    $d=$c-1;
    for ($i=1; $i<$c; $i++){
        $d=$d-$p;
        if ($d<=0){ return $i; }
    }
}


private function build_page()
{

    echo '<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
    <title>Mailbox</title>
    <link rel="stylesheet" type="text/css" href="screen.css" media="screen">
    <script type="text/javascript" src="script/admin.js"></script>
    <script type="text/javascript" src="script/mail.js"></script>
    </head>
    <body>
    <center>
    <div id="main">
    <div id="top">
    <img style="float:left;clear:left;" border="0" src="logo.gif"/>
    <div id="topmenu">
    &nbsp;|&nbsp;<a href="http://'.getenv("HTTP_HOST").'">Home</a>&nbsp;|&nbsp;';
    echo '&nbsp;|&nbsp;<a target="_blank" href="http://ramui.com/contact-form-without-mail-documentation.php">Documentation</a>
    &nbsp;|&nbsp;<a target="_blank" href="http://ramui.com/forum/">Help</a>';

    if (($_SESSION['admin'])=='yes'){
       echo '&nbsp;|&nbsp;&nbsp;|&nbsp;<a href="index.php?qur=5M1">Logout</a>';}

    echo '&nbsp;&nbsp;</div><br/><br/><span style="font-size:24px;"><i>Ajax CONTACT FORM v1.0</i></span></div><div id="feedback"></div>';
}


private function show_empty()
{
    if (($_SESSION['admin'])=='yes'){
        unset($_SESSION['admin']);
        @file_put_contents("database/settings.php", "");
    }
    $this->build_page();
    echo 'Your Mailbox is empty!';
    $this->build_footer();
}


private function log_in()
{
$this->build_page();
echo '<form method="POST" style="text-align:left; padding-left:10px;" action="index.php"><br/><big><u>Administrator login:</u></big><table style="margin:10px;width:300px;"><tr><td>User:</td><td><input type="text" style="border:1px solid #c0c0c0;" name="name" size="20"></td></tr><tr><td>Password:</td><td><input type="password" style="border:1px solid #c0c0c0;" name="password" size="20"></td></tr><tr><td colspan="2" style="padding-top:20px;"><input type="submit" value="Submit" name="B1">&nbsp;&nbsp;<input type="reset" value="Reset" name="B2"></td></tr></table></form>';
$this->build_footer();
}


private function show_list($page)
{
    $this->build_page();
    $lines=file($this->filename);
    $line_count=count($lines);
    $start_count=($line_count-1)-($page-1)*$this->list_perpage;
    $end_count=0;
    if($start_count>$this->list_perpage) {$end_count=$start_count-$this->list_perpage; }
    $totalpage=$this->total_page($line_count, $this->list_perpage);

    echo '<table id="mailbox"><tr style="background-color:#5c7283; color:#ffffff;"><td width="50%"><b>Subject</b></td><td width="25%"><b>From</b></td><td  width="25%"><b>Date</b></td></tr>';

    $ncolor=false;
    for($i=$start_count; $i>$end_count; $i--) {
        $ncolor=!$ncolor;
        $data=explode("<>", $this->strip_slashes($lines[$i]));
        if ($ncolor){echo '<tr style="background-color:#f0f0f0;">';}
        else { echo '<tr style="background-color:#e0e0e0;">';}
        echo '<td><a href="index.php?qur=1M'.$i.'">'.$data[1].'</a><br>'.$this->preview(trim($data[4])).'</td><td>'.$data[2].'</td><td>'.$data[3].'</td></tr>';
    }

    echo '<tr><td colspan="3"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';

    if ($page<=1){ echo '<span style="color:#808080;">Previous</span>&nbsp;|&nbsp';}
    else { echo '<a href="index.php?qur=0M1M'.($page-1).'">Previous</a>&nbsp;|&nbsp';}
    if ($page>=$totalpage){ echo '<span style="color:#808080;">Next</span>&nbsp;|&nbsp';}
    else { echo '<a href="index.php?qur=0M1M'.($page+1).'">Next</a>&nbsp;|&nbsp';}

    echo '</td></tr></table>';
    $this->build_footer();
}

private function preview($s)
{
    $str=str_replace('<p>', ' ', $s);
    $str=str_replace('</p>', ' ', $str);
    $str=str_replace('<br>', ' ', $str);
    $str=substr($str, 0, 127).'...';
    return $str;
}

private function show_message($message_number)
{
    $this->build_page();

        $lines = file($this->filename);
        $data = explode("<>", $this->strip_slashes($lines[$message_number]));
        $next_number = $message_number+1;
        $previous_number = $message_number-1;
        $str=substr(bin2hex($data[1].$data[2].$data[3]),0,100);
        $str = "'?qur=2M".$message_number."M".$str."'";

        echo '<table id="menu"><tr><td><a href="index.php">Inbox</a></td><td><a href="javascript:delete_message('.$str.')">Delete</a></td>';

        if ($message_number>1) { echo '<td><a href="index.php?qur=1M'.$previous_number.'">Previous Message</a></td>';}
        else{ echo '<td style="color:#cccccc;">Previous Message</td>';}

        if (($message_number+1)< count($lines)) { echo '<td><a href="index.php?qur=1M'.$next_number.'">Next Message</a></td>';}
        else{ echo '<td style="color:#cccccc;">Next Message</td>';}

        echo '<td><a href="index.php?3M'.$message_number.'">Save text</a></td><td style="border:none;"><a href="index.php?4M'.$message_number.'">Save html</a></td></tr></table>';

        echo '<div id="messagebox">From:&nbsp;<a href="mailto:'.$data[2].'">'.$data[5].'</a><br>IP:&nbsp;'.$data[0].'<br>Subject:&nbsp;'.$data[1].'<br>Date:&nbsp;'.$data[3].'<hr/>'.$data[4].'</div>';

    $this->build_footer();
}


private function savemessage_html($message_number)
{
    $lines=file($this->filename);
    $d=explode("<>", $lines[$message_number]);
    $s='<html><head><title>Message'.$message_number.'</title></head><body><div style="width:600px;">';
    $s.='From:&nbsp;<a href="mailto:'.$d[2].'">'.$d[5].'</a><br/>I.P.:&nbsp;' .$d[0].'<br>Subject:&nbsp;'.$d[1].'<br>Date:&nbsp;'.$d[3].'<br/><hr/>'.$d[4].'</div></body></html>';
    $f='message'.$message_number.'.html';
    @header("Content-type: application/text");
    @header("Content-Disposition: attachment; filename=$f");
    echo $s;
    return;
}


private function savemessage_text($message_number)
{
    $lines=file($this->filename);
    $d=explode("<>", trim($lines[$message_number]));
    $s=str_replace('<p>',chr(13).chr(10),$d[4]);
    $s=str_replace('</p>','',$s);
    $s=str_replace('<br>',chr(13).chr(10),$s);
    $s='From: '.$d[5].' ('.$d[2].')'.chr(13).chr(10).'I.P.: '.$d[0].chr(13).chr(10).'Subject: '.htmlspecialchars_decode($d[1]).chr(13).chr(10).'Date: '.$d[3].chr(13).chr(10).str_repeat("_",45).chr(13).chr(10).htmlspecialchars_decode($s);
    $f='message'.$message_number.'.rtf';
    @header("Content-type: application/text");
    @header("Content-Disposition: attachment; filename=$f");
    echo $s;
    return;
}


private function delete_message($message_number,$str)
{
          $stmp='';
          $f=file($this->filename);
          $c=count($f);
          for($i=0; $i<$c; $i++) {
          if (!($i==$message_number)){ $stmp.=$f[$i];}}
          file_put_contents($this->filename,$stmp);
          @header("Location: index.php");
}


private function install_now()
{
    $this->build_page();
    $str='<form name="frmInstall" method="POST" style="text-align:left; padding-left:10px;" action="index.php" OnSubmit="return validateForm()">
    <div style="clear:both; margin:10px; color:red;">
    <p><b>Important!</b></p>
    Before install set permission to "0777" or "777" of the followings:
    <ul style="list-style-type:disc;">
    <li>file=> mail/database/db.php;</li>
    <li>file=> mail/database/settings.php;</li>
    <p>Please don\'t use space in the "user" or "password" field. It will be discarded.</p>
    </div><br/><big><u>Install:</u></big><table style="margin:10px;width:300px;"><tr><td>User:</td><td><input type="text" style="border:1px solid #c0c0c0;" name="setname" size="20"></td></tr><tr><td>Password&nbsp<a href="javascript:generatePW()">Generate</a>:</td><td><input type="text" style="border:1px solid #c0c0c0;" name="setpassword" size="20"></td></tr>';
    $str.='<tr><td colspan="2" style="padding-top:20px;"><input type="submit" value="Submit" name="B1">&nbsp;&nbsp;<input type="reset" value="Reset" name="B2"></td></tr></table></form>';
    echo $str;
    $this->build_footer();
}


private function write_configuration()
{
    $name=str_replace(' ', '', $this->strip_slashes($_POST['setname']));
    $pw=str_replace(' ', '', $this->strip_slashes($_POST['setpassword']));
    $selfurl = str_replace("www.","", strtolower(getenv("HTTP_HOST")));

    $handle=fopen($this->configfile,'w');
    fwrite($handle,'<?php exit; ?>');
    fwrite($handle,"\n");
    fwrite($handle, $selfurl.'< >'.$name.'< >'.$pw);
    fwrite($handle,"\n");
    fclose($handle);
    @header("Location: index.php?qur=5Mx");
}

private function strip_slashes($str)
{
    if (get_magic_quotes_gpc()){return stripslashes($str);}
    return $str;
}

private function build_footer()
{
echo '<div id="bottom">PHP contact-form &copy;&nbsp<a target="_blank" href="http://ramui.com/">http://ramui.com</a>. All rights reserved.</div></div></center></body></html>';
}

public function get_query()
{
$this->configfile=str_replace("index.php", "database/config.php", __FILE__);
if(!(filesize($this->configfile)>10)){
    if (!((empty($_POST['setpassword']))&&(empty($_POST['setname'])))){
        $this->write_configuration();
        return;
    }
    $this->install_now();
    return;
}

$configline=file($this->configfile);
$config=explode('< >', $this->strip_slashes($configline[1]));
$this->url=$config[0];
$this->user=$config[1];
$this->pw=trim($config[2]);

if ((!(empty($_GET['sendmail'])))&&($_GET['sendmail']=='true')){
    $this->send_mail();
    return;
}

if (count(file($this->filename))<2){
        $this->show_empty();
        return;}

if ($this->validate_user()){
if (strpos($_SERVER['REQUEST_URI'], "?") === false) {
    $this->show_list(1);
    return;
}

$s = explode("?", $_SERVER['REQUEST_URI']);

$query= explode("M" , str_replace("qur=", "", $s[1]));
switch ($query[0]) {
    case "0":
        $this->show_list($query[2]);
    break;
    case "1":
        $this->show_message($query[1]);
    break;
    case "2":
        $this->delete_message($query[1],$query[3]);
    break;
    case "3":
        $this->savemessage_text($query[1]);
    break;
    case "4":
        $this->savemessage_html($query[1]);
    break;
    case "5":
        $this->log_out();
    break;
    default :
        $this->show_list(1);
}}
else { $this->log_in();}

}

private function mymail($n, $f, $s, $m)
{
    $msg=$_SERVER['REMOTE_ADDR']."<>".$s."<>".$f."<>".date('d.m.Y H:i')."<>".$m."<>".$n;
    $handle = @fopen ($this->filename, 'a');
    @fwrite($handle,$msg);
    @fwrite($handle,"\n");
    @fclose($handle);
}

private function send_mail()
{
    if(!(bin2hex($_SESSION['captcha_code']) == bin2hex($_POST['captcha_code']) && !empty($_SESSION['captcha_code'] ))){
        echo '<span style="color:red; background:#ffffff;">Wrong varification code! Please try again.</span>';
        return;
    }

    $subject = htmlspecialchars( $this->strip_slashes(rawurldecode($_REQUEST["subject"])));
    if (empty($subject)){ $subject="none";}

    $message = "<p>".htmlspecialchars( $this->strip_slashes(rawurldecode($_REQUEST["message"])))."</p>";
    $message = str_replace (chr(13),"<br>",$message);
    $message = str_replace (chr(10),"<br>",$message);
    $message = str_replace ("<br><br>","</p><p>",$message);

    $from = htmlspecialchars( $this->strip_slashes(rawurldecode($_REQUEST["from"])));
    $name = htmlspecialchars( $this->strip_slashes(rawurldecode($_REQUEST["name"])));

    $this->mymail($name, $from, $subject, $message);
    unset($_SESSION['captcha_code']);
    echo '<span style="color:green; background:#ffffff;">Your message has been successfully send.</span>';
}

}
session_start();
$page=new admin();
$page->get_query();
?>